/* ***** BEGIN LICENSE BLOCK *****
 
 
 Copyright 2012 Adam Skillen (a_skil(at)encs.concordia.ca), Mohammad Mannan (mmannan(at)encs.concordia.ca)
 
 Redistribution and use in source and binary forms, with or without modification,
 are permitted provided that the following conditions are met:
 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.  Redistributions in
 * binary form must reproduce the above copyright notice, this list of
 * conditions and the following disclaimer in the documentation and/or other
 * materials provided with the distribution.  Neither the name of Carleton
 * University nor the names of its contributors may be used to endorse or
 * promote products derived from this software without specific prior written
 * permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 * ***** END LICENSE BLOCK ***** */
   
 /**
  * 09-MAY-12
  * 	TODO:  0
  * 	FIXME: 1
  * 	NOTE:  0
  */ 
 Components.utils.import("resource://myphrase/common.js");
 Components.utils.import("resource://myphrase/commonWords.js");
 Components.utils.import("resource://myphrase/POSTagger.js");

/**
 * MyphraseCCSLOptions namespace.
 */
if ("undefined" == typeof(MyphraseCCSLGenMaster)) {
  var MyphraseCCSLGenMaster = {};
};


/**
 * Indicates whether or not this string starts with the specified string.
 * @param {Object} string
 */
String.prototype.startsWith = function(string){
    if (!string) 
        return false;
    return this.indexOf(string) == 0;
}

/**
 * Indicates whether or not this string ends with the specified string.
 * @param {Object} string
 */
String.prototype.endsWith = function(string){
    if (!string || string.length > this.length) 
        return false;
    return this.indexOf(string) == this.length - string.length;
}


MyphraseCCSLGenMaster.BrowserOverlay = {
  prefs: null,
  promptService: null,
  masterLength: 0,
  numWords: 0,
  template: [],
  words: [],
  regenCount: 0,
  CC: MyphraseCCSL.words.CC,	// Coord Conjuncn
  DT: MyphraseCCSL.words.DT,	// Determiner
  EX: MyphraseCCSL.words.EX,	// Existential there
  IN: MyphraseCCSL.words.IN,	// Preposition
  JJ: [],
  MD: MyphraseCCSL.words.MD,	// Modal
  NN: [],
  PRP$: MyphraseCCSL.words.PRP$,	// Possessive pronoun
  PRP: MyphraseCCSL.words.PRP,	// Personal pronoun
  RB: [],	// Adverb
  RP: MyphraseCCSL.words.RP,	// Particle
  TO: MyphraseCCSL.words.TO,// to
  UH: MyphraseCCSL.words.UH,	// Interjection
  VB: [],	// verb, base form			(eat)
  WP: MyphraseCCSL.words.WP,	//  Wh pronoun               who,what
  
  
  onLoad: function() {
	this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
	  .getService(Components.interfaces.nsIPrefService)
	  .getBranch("extensions.myphrase.");

	this.promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                              .getService(Components.interfaces.nsIPromptService);
	
	//Make sure the preferences are actually set
	var pathToDictionary = this.prefs.getCharPref("pathToDict");
	if (pathToDictionary == "") {
		this.promptService.alert(null, "Need a Dictionary File", "Please set the path to your dictionary file in the Myphrase preferences");
		window.close();
	}
	
	// get master passphrase length
	this.masterLength = this.prefs.getIntPref("masterLengthPref");

	// dynamically draw textboxes and checkboxes
	var dialog = document.getElementById("myphraseGenerateMaster");
	
	for (var i = 0; i < this.masterLength; i++) {
		const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
		var passBox = document.createElementNS(XUL_NS, "textbox"); // create a new XUL menuitem
		var passChk = document.createElementNS(XUL_NS, "checkbox");
		var hbox = document.createElementNS(XUL_NS, "hbox");
		passBox.setAttribute("id", "passBox" + i);
		passChk.setAttribute("id", "passChk" + i);
		passChk.setAttribute("checked", "false");
		dialog.appendChild(hbox);
		hbox.appendChild(passBox);
		hbox.appendChild(passChk);
	}
	
	var vbox = document.createElementNS(XUL_NS, "vbox");
	
	var fullText = document.createElementNS(XUL_NS, "label");
	fullText.setAttribute("id", "fullText");
	fullText.setAttribute("style", "font-weight: bold;");
	fullText.setAttribute("value", "");
		
	var spacer1 = document.createElementNS(XUL_NS, "separator");
	var spacer2 = document.createElementNS(XUL_NS, "separator");
	var spacer3 = document.createElementNS(XUL_NS, "separator");
	var spacer4 = document.createElementNS(XUL_NS, "separator");
	spacer1.className = "thin";
	spacer2.className = "thin";
	spacer3.className = "thin";
	spacer4.className = "thin";
	
	var gbox = document.createElementNS(XUL_NS, "groupbox");
	gbox.setAttribute("align", "center");
	gbox.setAttribute("orient", "vertical");

	gbox.appendChild(vbox);
	vbox.appendChild(spacer1);
	vbox.appendChild(fullText);
	vbox.appendChild(spacer2);
	dialog.appendChild(spacer3);
	dialog.appendChild(gbox);
	dialog.appendChild(spacer4);
	
   	this.prepDict();

	this.GenMyphrase();
	
	// set regen count
	this.regenCount = this.masterLength;
	document.getElementById("regen").value = "You may regenerate " + this.regenCount + " words.";
  },
  
  prepDict: function() {
  	
	// load dictionary into an nsIFile from prefs string
	var dictFilePath = this.prefs.getCharPref("pathToDict");
	var data = MyphraseCCSL.Common.GetFileContent("file://"+dictFilePath);
	
	// load dictionary words into an array (account for CR+LF)
	data = data.replace(/\s{2,}/g," ");
	this.words = data.split(/\s/);

	// FIXME: Add these common words to dictionary for Random Sequence?
	//var freqWords = [];
	//freqWords = freqWords.concat(this.CC, this.DT, this.EX, this.IN, this.MD, this.PRP$, this.PRP, this.RP, this.TO, this.UH, this.WP);
    //this.words = this.words.concat(freqWords);

	this.numWords = this.words.length;
	
	// tag POS for words
	var tags = MyphraseCCSL.POSTagger.tag(this.words);
	

	// sort tags in arrays
	for (t in tags) {
	
		if (typeof(tags[t][1]) == "undefined") {
			continue;
		}
	
	    if (tags[t][1].endsWith("DT")) {
	    if (this.DT.indexOf(tags[t][0]) < 0)
			this.DT.push(tags[t][0]);
		} else if (tags[t][1] == "CC") {
			if (this.CC.indexOf(tags[t][0]) < 0)
			this.CC.push(tags[t][0]);
		} else if (tags[t][1] == "IN") {
			if (this.IN.indexOf(tags[t][0]) < 0)
			this.IN.push(tags[t][0]);
		} else if (tags[t][1].startsWith("JJ")) {
			if (this.JJ.indexOf(tags[t][0]) < 0)
			this.JJ.push(tags[t][0]);
		} else if (tags[t][1] == "MD") {
			if (this.MD.indexOf(tags[t][0]) < 0)
			this.MD.push(tags[t][0]);
		} else if (tags[t][1].startsWith("NN")) {
			if (this.NN.indexOf(tags[t][0]) < 0)
			this.NN.push(tags[t][0]);
		} else if (tags[t][1] == "PRP") {
			if (this.PRP.indexOf(tags[t][0]) < 0)
			this.PRP.push(tags[t][0]);
		} else if (tags[t][1] == "PRP$") {
			if (this.PRP$.indexOf(tags[t][0]) < 0)
			this.PRP$.push(tags[t][0]);
		} else if (tags[t][1].startsWith("RB") || tags[t][1].endsWith("RB")) {
			if (this.RB.indexOf(tags[t][0]) < 0)
			this.RB.push(tags[t][0]);
		} else if (tags[t][1] == "RP") {
			if (this.RP.indexOf(tags[t][0]) < 0)
			this.RP.push(tags[t][0]);
		} else if (tags[t][1] == "UH") {
			if (this.UH.indexOf(tags[t][0]) < 0)
			this.UH.push(tags[t][0]);
		} else if (tags[t][1].startsWith("VB")) {
			if (this.VB.indexOf(tags[t][0]) < 0)
			this.VB.push(tags[t][0]);
		} else if (tags[t][1].startsWith("WP")) {
			if (this.WP.indexOf(tags[t][0]) < 0)
			this.WP.push(tags[t][0]);
		}
	}
  }, 
  
  
  resetMyp: function(event) {
    
    for (j = 0; j < this.masterLength; j++) {
        var passChk = document.getElementById("passChk" + j);
	    passChk.checked = false;
    }
    this.regenCount = this.masterLength;
    this.GenMyphrase(event);
    this.regenCount = this.masterLength;
    document.getElementById("regen").value = "You may regenerate " + this.regenCount + " words.";
  },
  
  GenMyphrase: function(event) {
    if (document.getElementById("conDisc").selected == true) {
        this.GenMyphraseConDisc(event);
    } else if (document.getElementById("randSeq").selected == true) {
        this.GenMyphraseRandSeq(event);
    } else {
        // something went wrong
        alert("error: unknown phrase type");
    }
    // return false so the window doesn't close on "Generate" button
	return false;
  },
  
  GenMyphraseRandSeq: function(event) {
    var notChecked = 0;
    var fullText = "";
    for (i = 0; i < this.masterLength; i++) {
    // insert random word into box
		var passBox = document.getElementById("passBox" + i);
		var passChk = document.getElementById("passChk" + i);
		if (!passChk.checked) {
			notChecked += 1;
			var rnd = this.CSRNG(this.words.length);
			w = this.words[rnd];
			passBox.value = w;
			// reset if user goes over regen limit
		    if (--this.regenCount < 0) {
		        this.resetMyp();
		        return;
		    } else {
		        document.getElementById("regen").value = "You may regenerate " + this.regenCount + " words.";
		    }
		}
		fullText += (passBox.value + " ");
	}
	if (notChecked == this.masterLength) {
		this.regenCount = this.masterLength;
    		document.getElementById("regen").value = "You may regenerate " + this.regenCount + " words.";
	}
	var fullTextXUL = document.getElementById("fullText");
	fullTextXUL.value = fullText;
  },

  GenMyphraseConDisc: function(event) {
    
    // for entropy calculation
    function lg(val) {
      return Math.log(val) / Math.log(2);
    }

    // sentence templates for different lengths.  Current settings allow 4 to 12
    var fourWord = [["JJ", "NN", "RB", "VB"], 
    	["NN", "CC", "NN", "VB"], 
        ["DT", "NN", "VB", "RB"], 
        ["PRP", "VBN", "PRP", "IN"], 
        ["DT","JJ", "NN", "VBZ"], 
        ["DT","NN", "VBD", "JJ"], 
        ["DT", "NN", "VBD", "RB"]];
        
    var fiveWord = [["PRP", "MD", "VB", "PRP", "RB"], 
    	["CC", "VBZ", "DT", "JJ", "NN"],
        ["DT", "NN", "VBP", "JJ", "NN"], 
        ["MD", "DT", "JJ", "NN", "VB"], 
        ["DT", "JJ", "NN", "VB", "NN"], 
        ["WP", "VBD", "DT", "JJ", "NN"], 
        ["JJ", "NN", "VB", "IN", "NN"], 
        ["DT", "JJ", "NN", "VBD", "RB"],
        ["PRP", "VBD", "RB", "RB", "VBG"]];
        
        var sixWord = [["PRP$", "JJ", "NN", "VBD", "CC", "VBN"], 
    	["PRP", "NN", "TO", "VB", "DT", "NN"],
       // ["MD", "PRP", "VB", "RB", "IN", "PRP"], 
       // ["PRP", "MD", "VBP", "IN", "DT", "NN"], 
        ["DT", "NN", "NN", "VBD", "VBN", "VBD"], 
        ["PRP", "VBP", "RB", "CC", "RB", "JJ"], 
        ["DT", "NN", "VBZ", "JJ", "IN", "RB"],
        ["JJ", "NN", "CC", "NN", "VB", "RB"],
        ["PRP", "CC", "DT", "NN", "VB", "RB"]];
        
    var sevenWord = [["PRP$", "JJ", "NN", "VBD", "CC", "VBN", "RB"],
    	["PRP", "VBD", "IN", "JJ", "NN", "VBN", "RB"],
        ["PRP", "MD", "VBN", "DT", "NN", "IN", "NN"],
        ["JJ", "NN", "CC", "JJ", "NN", "VB", "RB"], 
        ["DT", "JJ", "CC", "JJ", "NN", "VB", "RB"],
       // ["NN", "VBD", "VBN", "CC", "VBD", "PRP$", "NN"],
       // ["PRP", "VBD", "IN", "TO", "VB", "PRP$", "NN"], 
        ["PRP", "VBN", "PRP$", "IN", "PRP$", "JJ", "NN"],
        ["CC", "PRP$", "VBG", "NN", "VBD", "VBN", "PRP$"]];
        
    var eightWord = [["NN", "VBD", "IN", "DT", "NN", "VBN", "IN", "NN"],
        ["DT", "NN", "VBD", "RB", "VBN", "IN", "DT", "NN"], 
        ["NN", "CC", "NN", "VBD", "RB", "IN", "DT", "NN"],
        ["IN", "PRP", "VBD", "RB", "PRP$", "NN", "VBD", "RB"],
        ["DT", "JJ", "NN", "RB", "VB", "TO", "DT", "NN"],
        ["RB", "VB", "JJ", "NN", "VB", "TO", "DT", "NN"],
       // ["PRP", "VBN", "PRP$", "IN", "PRP$", "JJ", "JJ", "NN"],
       // ["PRP", "VBD", "RB", "IN", "PRP", "VB", "PRP", "RB"],
        ["CC", "PRP$", "VBG", "JJ", "NN", "VBD", "VBN", "PRP$"]];
        
    var nineWord = [["PRP", "VBD", "VBD", "PRP$", "NN", "RB", "IN", "PRP$", "RB"],
        ["IN", "PRP", "VBD", "RB", "PRP$", "JJ", "NN", "VBD", "RB"],
        ["DT", "NN", "VBD", "CC", "VBD", "TO", "PRP$", "VBG", "NN"],
        ["DT", "JJ", "NN", "VBD", "DT", "NN", "CC", "DT", "NN"],
        ["PRP", "VBD", "RB", "VB", "RB", "JJ", "IN", "TO", "VBP"]];
        
    var tenWord = [["DT", "NN", "VBD", "CC", "VBD", "TO", "PRP$", "VBG", "JJ", "NN"],
        ["DT", "JJ", "NN", "VBD", "DT", "NN", "CC", "DT", "JJ", "NN"],
        ["PRP", "VBD", "PRP$", "NN", "IN", "DT", "NN", "IN", "DT", "NN"],
        ["CC", "PRP", "VBD", "PRP$", "RB", "PRP", "MD", "VBP", "PRP", "VBD"],
        ["PRP", "VBD", "JJ", "IN", "DT", "NN", "IN", "NN", "CC", "NN"],
        ["CC", "NN", "VBD", "DT", "JJ", "NN", "IN", "PRP", "IN", "NN"]];
        
    var elevenWord = [["PRP", "VBD", "IN", "CC", "VBD", "DT", "NN", "IN", "DT", "JJ", "NN"],
        ["PRP", "VBD", "RB", "PRP$", "NN", "IN", "DT", "NN", "IN", "DT", "NN"],
        ["CC", "PRP", "VBD", "PRP$", "RB", "PRP", "MD", "VBP", "PRP", "VBD", "RB"],
        ["RB", "PRP", "VBD", "JJ", "IN", "DT", "NN", "IN", "NN", "CC", "NN"],
        ["CC", "NN", "VBD", "DT", "JJ", "NN", "IN", "PRP", "IN", "JJ", "NN"]];
        
    var twelveWord = [
    	["PRP", "VBD", "IN", "CC", "VBD", "DT", "NN", "IN", "DT", "JJ", "JJ", "NN"],
        ["PRP", "VBD", "IN", "PRP", "IN", "DT", "NN", "CC", "VBD", "DT", "JJ", "NN"],
        ["PRP", "VBD", "PRP$", "NN", "IN", "PRP$", "CC", "VBD", "IN", "DT", "NN", "RB"],
        ["RB", "PRP", "VBD", "JJ", "IN", "DT", "NN", "IN", "NN", "CC", "JJ", "NN"]];

    // if the user checked any boxes use the same template
    var chooseRandom = true;
    var notChecked = 0;

    for (j = 0; j < this.masterLength; j++) {
    	var passChk = document.getElementById("passChk" + j);
	if (passChk.checked) {
	    chooseRandom = false;
	} else  {
		notChecked += 1;
		if (--this.regenCount < 0) {
			this.resetMyp();
			return;
		}
		document.getElementById("regen").value = "You may regenerate " + this.regenCount + " words.";
	}
    }
	if (notChecked == this.masterLength) {
		this.regenCount = this.masterLength;
		document.getElementById("regen").value = "You may regenerate " + this.regenCount + " words.";
	}

    if (chooseRandom) {
        // randomly choose a template using a CSRNG
        if (this.masterLength == 4) {
            rnd = this.CSRNG(fourWord.length);
            this.template = fourWord[rnd];
        } else if (this.masterLength == 5) {
            rnd = this.CSRNG(fiveWord.length);
            this.template = fiveWord[rnd];
        } else if (this.masterLength == 6) {
            rnd = this.CSRNG(sixWord.length);
            this.template = sixWord[rnd];
        } else if (this.masterLength == 7) {
            rnd = this.CSRNG(sevenWord.length);
            this.template = sevenWord[rnd];    
        } else if (this.masterLength == 8) {
            rnd = this.CSRNG(eightWord.length);
            this.template = eightWord[rnd];         
        } else if (this.masterLength == 9) {
            rnd = this.CSRNG(nineWord.length);
            this.template = nineWord[rnd];         
        } else if (this.masterLength == 10) {
            rnd = this.CSRNG(tenWord.length);
            this.template = tenWord[rnd];         
        } else if (this.masterLength == 11) {
            rnd = this.CSRNG(elevenWord.length);
            this.template = elevenWord[rnd];         
        } else if (this.masterLength == 12) {
            rnd = this.CSRNG(twelveWord.length);
            this.template = twelveWord[rnd];         
        }
    }
	
	
	var fullText = ""; // the full sentence
	var entropy = 1;
	var entropyT = "";
    
	// choose a word for each tag in template
	for (i in this.template) {
		if (this.template[i] == "CC") {
			rnd = this.CSRNG(this.CC.length);
			w = this.CC[rnd];
			entropy *= this.CC.length;
			entropyT = entropyT + this.CC.length + " ";
		} else if (this.template[i].endsWith("DT")) {
			rnd = this.CSRNG(this.DT.length);
			w = this.DT[rnd];
			entropy *= this.DT.length;
			entropyT = entropyT + this.DT.length + " ";
		} else if (this.template[i] == "IN") {
			rnd =this.CSRNG(this.IN.length);
			w = this.IN[rnd];
			entropy *= this.IN.length;
			entropyT = entropyT + this.IN.length + " ";
		} else if (this.template[i] == "JJ") {
			rnd =this.CSRNG(this.JJ.length);
			w = this.JJ[rnd];
			entropy *= this.JJ.length;
			entropyT = entropyT + this.JJ.length + " ";
		} else if (this.template[i] == "MD") {
			rnd =this.CSRNG(this.MD.length);
			w = this.MD[rnd];
			entropy *= this.MD.length;
			entropyT = entropyT + this.MD.length + " ";
		} else if (this.template[i] == "NN") {
			rnd =this.CSRNG(this.NN.length);
			w = this.NN[rnd];
			entropy *= this.NN.length;
			entropyT = entropyT + this.NN.length + " ";
		} else if (this.template[i] == "PRP") {
			rnd =this.CSRNG(this.PRP.length);
			w = this.PRP[rnd];
			entropy *= this.PRP.length;
			entropyT = entropyT + this.PRP.length + " ";
		} else if (this.template[i] == "PRP$") {
			rnd =this.CSRNG(this.PRP$.length);
			w = this.PRP$[rnd];
			entropy *= this.PRP$.length;
			entropyT = entropyT + this.PRP$.length + " ";
		} else if (this.template[i].startsWith("RB") || this.template[i].endsWith("RB")) {      
			rnd =this.CSRNG(this.RB.length);
			w = this.RB[rnd];
			entropy *= this.RB.length;
			entropyT = entropyT + this.RB.length + " ";
		} else if (this.template[i] == "RP") {
			rnd =this.CSRNG(this.RP.length);
			w = this.RP[rnd];
			entropy *= this.RP.length;
			entropyT = entropyT + this.RP.length + " ";
		} else if (this.template[i] == "UH") {
			rnd =this.CSRNG(this.UH.length);
			w = this.UH[rnd];
			entropy *= this.UH.length;
			entropyT = entropyT + this.UH.length + " ";
		} else if (this.template[i].startsWith("VB")) {  //} else if (this.template[i] == "VB") {
			rnd =this.CSRNG(this.VB.length);
			w = this.VB[rnd];
			entropy *= this.VB.length;
			entropyT = entropyT + this.VB.length + " ";
		} else if (this.template[i].startsWith("WP")) {
			rnd =this.CSRNG(this.WP.length);
			w = this.WP[rnd];
			entropy *= this.WP.length;
			entropyT = entropyT + this.WP.length + " ";
		} else if (this.template[i] == "EX") {
			rnd =this.CSRNG(this.EX.length);
			w = this.EX[rnd];
			entropy *= this.EX.length;
			entropyT = entropyT + this.EX.length + " ";
		} else if (this.template[i] == "TO") {
			rnd =this.CSRNG(this.TO.length);
			w = this.TO[rnd];
			entropy *= this.TO.length;
			entropyT = entropyT + this.TO.length + " ";
		}
		
		// insert random word into box
		var passBox = document.getElementById("passBox" + i);
		var passChk = document.getElementById("passChk" + i);
		if (!passChk.checked) {
			passBox.value = w;
		}
		fullText += (passBox.value + " ");
	}
	
	var fullTextXUL = document.getElementById("fullText");
	fullTextXUL.value = fullText;

	/*	
	alert("Entropy: " + lg(entropy) + 
	    "\r\nCalc: " + entropyT +
	    "\r\nDict. Size: " + this.numWords +
	    "\r\nrandom would give: " + lg(Math.pow(this.numWords + 214, this.masterLength)));
	*/
 },
 
 
    CSRNG: function(numWords) {
	    /* get some random bytes (used for Moz SSL (NSS) PKCS#11, mouse movement for entropy)
	     * from https://developer.mozilla.org/en/Code_snippets/Miscellaneous
	     * also see https://developer.mozilla.org/en/XPCOM_Interface_Reference/nsIRandomGenerator 
         *          http://mxr.mozilla.org/seamonkey/source/security/manager/ssl/src/nsRandomGenerator.cpp
         *          http://mxr.mozilla.org/seamonkey/source/dom/src/base/nsGlobalWindow.cpp

	     */
	    var prng = Components.classes['@mozilla.org/security/random-generator;1']  
		    .getService(Components.interfaces.nsIRandomGenerator);


        function lg(val) {
	        return Math.log(val) / Math.log(2);
        }
        
        var bitsRequired = Math.ceil(lg(numWords));
        var bytesRequired = Math.ceil(bitsRequired / 8);
        var bitmask = (1 << bitsRequired) - 1;
        var buffer = '';
        var bytebucket = [];
        var rData = 0;
        
		bytebucket = prng.generateRandomBytes(bytesRequired, buffer);
		for (var j = 0; j < bytesRequired; j++) {
			rData = (rData << 8);
			rData = (rData | bytebucket[j]);
		}
		
		rData = (rData & bitmask);
		var rand = Math.floor((rData > 0 ? rData / bitmask : 0) * (numWords - 1));
        
        return rand;
    },

};

window.addEventListener("load", function(e) { MyphraseCCSLGenMaster.BrowserOverlay.onLoad(e); }, false);
