var EXPORTED_SYMBOLS = [ "MyphraseCCSL" ];

const Cc = Components.classes;
const Ci = Components.interfaces;

/**
 * MyphraseCCSL namespace.
 */
if ("undefined" == typeof(MyphraseCCSL)) {
  var MyphraseCCSL = {};
};

MyphraseCCSL.Common = {

  GetFileContent: function (aFileURL, fileSize) {
  // https://developer.mozilla.org/en/Code_snippets/File_I%2f%2fO#Binary_File

	var ios = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService);
	var url = ios.newURI(aFileURL, null, null);

	if (!url || !url.schemeIs("file")) 
		throw "Expected a file URL.";

	var bFile = url.QueryInterface(Components.interfaces.nsIFileURL).file;
	var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                          .createInstance(Components.interfaces.nsIFileInputStream);

	istream.init(bFile, -1, -1, Ci.nsIFileInputStream.CLOSE_ON_EOF);

	var bstream = Components.classes["@mozilla.org/binaryinputstream;1"]
                          .createInstance(Components.interfaces.nsIBinaryInputStream);
	
	bstream.setInputStream(istream);

	var bytes = bstream.readBytes(bstream.available());
	return bytes;
  },

  chromeToPath: function (aPath) {
  // chrome uri to file path from http://forums.mozillazine.org/viewtopic.php?p=921150#921150
	if (!aPath || !(/^chrome:/.test(aPath)))
		return; //not a chrome url
	var rv;
   
	var ios = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces["nsIIOService"]);
	var uri = ios.newURI(aPath, "UTF-8", null);
	var cr = Components.classes['@mozilla.org/chrome/chrome-registry;1'].getService(Components.interfaces["nsIChromeRegistry"]);
	rv = cr.convertChromeURL(uri).spec;

	if (/^file:/.test(rv))
		rv = urlToPath(rv);
	else
		rv = urlToPath("file://"+rv);

	return rv;

	function urlToPath (aPath) {
		if (!aPath || !/^file:/.test(aPath))
			return ;
		var rv;
		var ph = Components.classes["@mozilla.org/network/protocol;1?name=file"]
			.createInstance(Components.interfaces.nsIFileProtocolHandler);
		rv = ph.getFileFromURLSpec(aPath).path;
		return rv;
	}
  },

};
